!Subroutine devoted to the test of the HOAD modules (at the exception of math functions)

!Author: I. Charpentier

PROGRAM test_regression
USE HOAD_types; USE HOAD_add;  USE HOAD_div;    USE HOAD_prod; 
USE HOAD_power; USE HOAD_sub;  USE HOAD_uminus; USE HOAD_sqrt;
USE HOAD_real;  USE HOAD_aimag; USE HOAD_exp;   
USE HOAD_cos;   USE HOAD_sin
IMPLICIT NONE
REAL*8      :: a,b,c  !parameters
TYPE(real8d):: x,y    !evaluation point
TYPE(real8d):: z,w    !result

INTEGER     :: k      !loop index over the orders

 Ckmax=32; Ck=Ckmax

DO k=0,Ckmax
  x%d(k)=(k/10.d0+sqrt(2.d0))
  y%d(k)=(k*1.d0-sqrt(3.d0))
ENDDO

write(*,*)''; write(*,*) '         k       z=x**2 - x*x'
z=x**2 - x*x
DO k=0,Ckmax,5
  WRITE(*,*) k,z%d(k)
ENDDO

write(*,*)''; write(*,*) '         k       z=sqrt(x**2)-x            w=(x*x)**0.5d0-x'
z=sqrt(x**2)
w=(x*x*x)**(1.d0/3.d0)
DO k=0,Ckmax,5
  WRITE(*,*) k,z%d(k)-x%d(k),w%d(k)-x%d(k)
ENDDO

write(*,*)''; write(*,*) '         k       z=-(x/y)*y+x' 
z=1.d0/(1.d0/x)-x
DO k=0,Ckmax,5
  WRITE(*,*) k,z%d(k)
ENDDO

write(*,*)''; write(*,*) '         k       z-w                      z=x*(1.d0/y)              w=-x/y ' 
z=5.d0 -x*(1.d0/y) +2
w=5    -x/y        +2.d0
DO k=0,Ckmax,5
  WRITE(*,*) k,z%d(k)-w%d(k),z%d(k),w%d(k)
ENDDO

write(*,*)''; write(*,*) '         k       z=cos(x)**2+sin(x)**2-1' 
z=cos(x)**2+sin(x)**2-1
DO k=0,Ckmax,5
  WRITE(*,*) k,z%d(k)
ENDDO

END PROGRAM test_regression

!Copyright (c) 2016, CNRS and University of Strasbourg, France
!All rights reserved.

!Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

!1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

!2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

!3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

!THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
